/*===========================================================================
						Common javascript functions
  ===========================================================================*/

function _template()
{
	try
	{
	
	}
	catch(e)
	{
		errorMessage(e);
	}		
}
 /*--------------------------------------------------------------------------
						Common javascript functions - Database
   --------------------------------------------------------------------------*/
function db_openDatabase(database)
{
	var dbConnection = null;
	try
	{
		if(database)
		{
			infoMessage(5, "db_openDatabase(): started: " + database.path);

			var ios				= Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
			var sUri			= "file:///" + database.path;
			var uri				= ios.newURI(sUri, "", null);
			var nsifile			= uri.QueryInterface(Components.interfaces.nsIFileURL).file;
			var storageService	= Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);

			infoMessage(5, "db_openDatabase(): db path " + nsifile.path);

			dbConnection		= storageService.openDatabase(nsifile);
			
			infoMessage(5, "db_openDatabase(): db '" + dbConnection.databaseFile.path + "'; ready? " + dbConnection.connectionReady);
		} else {
			errorMessage("db_openDatabase(): No valid path to a database given!");
		}
	}
	catch(e)
	{
		errorMessage(e);
	}
	return dbConnection;
}

function db_closeDatabase(dbConnection)
{
	try
	{
		dbConnection.asyncClose();
	}
	catch(e)
	{
		errorMessage(e);
	}
}

function db_executeStatement(dbConnection, sql, fCompletion, oResultHandle)
{
	var aResult = null;
	try
	{
		infoMessage(5, "db_executeStatement(): started " + sql);

		var statement = dbConnection.createStatement(sql);

		statement.executeAsync(
			{
				handleResult: 
				function(aResultSet) 
				{
					infoMessage(5, "db_executeStatement(): handleResult: " + aResultSet);
					aResult = aResultSet;
				},

				handleError: 
				function(aError) 
				{
					infoMessage(5, "db_executeStatement(): handleError: " + aError.message);
					errorMessage("Error: " + aError.message);
				},

				handleCompletion: 
				function(aReason) 
				{
					infoMessage(5, "db_executeStatement(): handleCompletion: " + aReason);
					if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
					{
						errorMessage("Query canceled or aborted!");
					} else {
						fCompletion(aResult, oResultHandle);
					}					
				}
			}
		);
	}
	catch(e)
	{
		errorMessage(e);
	}
}
